<?php

namespace App\Services\Customer;

use App\Entities\Customer\CouponEntity;
use App\Models\Customer\CouponModel;
use App\Entities\Customer\ClientEntity;

class CouponService extends CustomerService
{
    public function __construct()
    {
        parent::__construct(new CouponModel());
        $this->addClassName('Coupon');
    }
    public function getFormFields(): array
    {
        return [
            'fields' => [
                "clientinfo_uid",
                "title",
                "cnt",
                "status",
            ],
            'filters' => [
                "clientinfo_uid",
                "status",
            ],
        ];
    }
    public function getIndexFields(): array
    {
        return [
            'fields' => [
                "clientinfo_uid",
                "title",
                "cnt",
                "status",
            ],
            'filters' => [
                "clientinfo_uid",
                "status",
            ],
        ];
    }
    public function getBatchjobFields(): array
    {
        return ['status'];
    }
    //기본 기능부분

    //고객예치금처리
    private function setBalance(array $formDatas): void
    {
        //coupon_balance 체크
        $entity = $this->getClientService()->getEntity($formDatas['clientinfo_uid']);
        if (!$entity) {
            throw new \Exception("{$formDatas['clientinfo_uid']}에 대한 고객정보를 찾을수 없습니다.");
        }
        $cnt = intval($formDatas['cnt']);
        if ($formDatas['status'] === CouponEntity::DEFAULT_STATUS) { //입금, 쿠폰추가
            $entity = $this->getClientService()->deposit($entity, 'coupon_balance',   $cnt);
        } else { // 출금, 쿠폰사용
            $entity = $this->getClientService()->withdrawal($entity, 'coupon_balance',   $cnt);
        }
    }
    public function create(array $formDatas): CouponEntity
    {
        $this->setBalance($formDatas);
        return parent::create($formDatas);
    }
}
